'
' -------------------------------------------------------------------
' Hash Table Demo        Main            Jacques     August 1st, 2011         
'
' requires a word list named EnglishWordsList.Txt
' -------------------------------------------------------------------
'
' English word list   http://www.mieliestronk.com/wordlist.html
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
$Include "CRC32.Inc"
$Include "CheckForTwins.Inc"
'
Type tTwin
    i As Integer
    j As Integer
    iMax as Integer
    jMax As Integer
End Type
'
'
Declare Sub OnClose_frmHashtable
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
Declare Function CreateIntegerArray (sWordlistFileName As String) As Long
Declare Sub iTableCheckForTwins
Declare Sub SortIntegerArray
Declare Sub SaveIntegerArray
Declare Sub LoadIntegerArray
Declare Function SearchInIntegerTable(sWord As String) As Integer  
Declare Sub SearchTests
'
Create frmHashtable As QForm
    Center
    Width = 800
    height = 800
    Caption = "frmHashtable"
    AutoScroll = False
    OnClose = OnClose_frmHashtable
    Create rchWin AS QRichEdit
        Align = 5
        Font.Name = "courier"    
        Font.Size = 12
        Font.Color = &H800000
        Font.Bold = True
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False 
        PlainText = True
    End Create
    Create mnuMain AS QMAINMENU
        Create mnuCreateArray AS QMENUITEM
            Caption = "&Create Integer Array"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuCheckForTwins AS QMENUITEM
            Caption = "C&heckForTwins"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuSortArray AS QMENUITEM
            Caption = "&Sort Integer Array"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuSaveArray AS QMENUITEM
            Caption = "Sa&ve Integer Array"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuLoadArray AS QMENUITEM
            Caption = "&Load Integer Array"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuSearchTests AS QMENUITEM
            Caption = "Search &Tests"
            OnClick = OnClic_AnyMenu
        End Create
    End Create
End Create
'
' --------------------------------------------------------------------
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, _
                                               nIndex AS LONG, dwNewLong AS LONG) AS LONG
setwindowlong(frmHashtable.handle, -8, 0)
setwindowlong(application.handle, -8, frmHashtable.handle)
' --------------------------------------------------------------------
DefInt flagMenuBusy = False
DefStr sAppDir = Command$(0) - Application.Exename
'
' *************************************
frmHashtable.Show
' *************************************
'
rchWin.AddString "\n 1 - Create the integer array from a words file named \"EnglishWordsList.Txt\""
rchWin.AddString   " 2 - Check for twins BEFORE SORTING THE ARRAY (optional)"
rchWin.AddString   " 3 - Sort the integer array"
rchWin.AddString   " 4 - Search for words demo (10000 search per second : a pity)"
rchWin.Addstring   " 5 - save and load sorted integer array.\n      Once the sorted array is created, it can simply be loaded"

rchWin.AddString "\n\nTEST CRC32 FUNCTION WITH KNOWN WORDS"
rchWin.Addstring "test_1 CRC32(\"resume\") = " & Hex$(CRC32String("resume")) & "    should be = &H60c1d0a0"
rchWin.Addstring "test_2 CRC32(\"resum\") = " & Hex$(CRC32String("resum")) & "    should be = &H84cf1fab\n"
'
Dim slTextDictionnary As QStringlist
DefInt iHashArray()
DefInt iHashArrayItemCount
'
' *************************************
frmHashtable.Visible = False
frmHashtable.ShowModal
' *************************************
'
Sub OnClose_frmHashtable
    Application.Terminate
End Sub
'
Sub OnClic_AnyMenu (Sender)
    If flagMenuBusy = True Then Exit Sub
    flagMenuBusy = true
    Select Case Sender.Handle
        Case mnuCreateArray.Handle
            CreateIntegerArray ("EnglishWordsList.Txt")
        Case mnuCheckForTwins.Handle
            iTableCheckForTwins
        Case mnuSortArray.Handle
            SortIntegerArray
        Case mnuSaveArray.Handle
            SaveIntegerArray
        Case mnuLoadArray.Handle
            LoadIntegerArray
        Case mnuSearchTests.Handle
            SearchTests
    End Select
    flagMenuBusy = False
End Sub
'
Function CreateIntegerArray (sWordlistFileName As String) As Long
    DefInt i
    DefSng iChrono = Timer
    If FileExists (sWordListFileName) = 0 Then
        ShowMessage ("File not found " & sWordListFileName & "\n\nGET A WORD LIST FILE read Read_Me.txt\n\nI Close")
        Application.Terminate
    End If
    slTextDictionnary.LoadFromFile (sWordlistFileName)
    iHashArrayItemCount = slTextDictionnary.ItemCount
    Redim iHashArray (0 To iHashArrayItemCount - 1) As Integer
    rchWin.Addstring "\nStart Hashing :  Timer = " & Str$(Timer) & " s"
    Doevents
    For i = 0 To iHashArrayItemCount - 1
        iHashArray(i) = CRC32String (slTextDictionnary.Item(i))
    Next i
    rchWin.Addstring "End   Hashing :  Timer = " & Str$(Timer) & " s"
    rchWin.Addstring "Table of " & Str$(iHashArrayItemCount) & " words hashed to an integer array done"
End Function
'
Sub iTableCheckForTwins
    Dim Twin as TTWIN
    DefInt iTwinCount = 0
    rchWin.Addstring "\nCHECKING FORE TWINS ... IT CAN TAKE A WHILE\n        (106 seconds here on an Intel 2GHz duo)"
    DoEvents
    rchWin.Addstring "Start Twins Check :  Timer = " & Str$(Timer) & " s"
  With slTextDictionnary
    Twin.iMax = .ItemCount - 2
    Twin.jMax = .ItemCount - 1
    Twin.i = 0
    Twin.j = 1
    While CheckForTwins (Twin, VarPtr(iHashArray(0)), 0, 0) <> 0
        Inc twin.j
        If twin.j = .ItemCount Then
            Inc twin.i
            If Twin.i = .Itemcount - 1 Then Exit while
            twin.j = twin.i + 1
        End If
        Inc iTwinCount
        rchWin.Addstring "Twins : \"" & .Item(twin.i) & "\" and \"" & .Item(twin.j) & "\"  hashed both to " & Hex$(iHashArray(twin.i))
    Wend
  End With
    rchWin.Addstring "End   Twins Check :  Timer = " & Str$(Timer) & " s"
    rchWin.Addstring "Total of " & Str$(iTwinCount) & " Twins found"
End Sub
'
Sub SortIntegerArray
  With slTextDictionnary
    rchWin.Addstring "\nStart Sorting Integer Array :  Timer = " & Str$(Timer) & " s"
    QuickSort(iHashArray(0), iHashArray(.ItemCount), ASCEND)
    rchWin.Addstring   "End   Sorting Integer Array :  Timer = " & Str$(Timer) & " s"
    rchWin.Addstring "Array of " & Str$(.ItemCount) & " integer Sorted"
  End With
End Sub
'
Sub SaveIntegerArray
    Dim fSave as QFileStream
    fSave.Open("IntegerWord.Tbl", fmCreate)
        fSave.SaveArray(iHashArray(0), 1 + Ubound(iHashArray))
    fSave.Close
    rchWin.AddString "\nInteger Array Saved as : \"IntegerWord.Tbl\""
End Sub
'
Sub LoadIntegerArray
    Dim fLoad as QFileStream
    If fLoad.Open("IntegerWord.Tbl", fmOpenRead) <> 0 Then
        Redim iHashArray (0 To ((fLoad.Size/4) - 1)) As Integer
        fLoad.LoadArray(iHashArray(0), fLoad.Size/4)
        rchWin.AddString "\nInteger Array Load from : \"IntegerWord.Tbl\" size : " &  Str$(fLOad.Size/4) & " integer"
    Else
        rchWin.Addstring "Cannot Load File ??? Do not exist ???"
    End If
    fLoad.Close
End Sub
'
Function SearchInIntegerTable(sWord As String) As Integer  
   DefInt iMiddle = 0
   DefInt iLBound = 0
   DefInt iUBound = UBound(iHashArray)
   DefInt iHash = CRC32String (sWord), N
   Do
     iMiddle = (iLBound + iUBound) \ 2
     If iHashArray(iMiddle) = iHash Then
       Result = iMiddle
       Exit Function
     ElseIf iHashArray(iMiddle) < iHash Then
       iLBound = iMiddle + 1
     Else
       iUBound = iMiddle - 1
     End If
   Loop Until iLBound > iUBound
   Result = -1
End Function
'
Sub SearchTests
    DefInt N
    rchWin.Addstring "\nSearch(\"banana\") : " & Str$(SearchInIntegerTable("banana"))
    rchWin.Addstring "Search(\"bananaa\") : " & Str$(SearchInIntegerTable("bananaa"))
    rchWin.Addstring "Search(\"bannana\") : " & Str$(SearchInIntegerTable("bannana"))
    rchWin.Addstring "Search(\"unconstitutionality\") : " & Str$(SearchInIntegerTable("unconstitutionality"))

    rchWin.Addstring "\nStart Searching 10000 words :  Timer = " & Str$(Timer) & " s"
    For N = 1 To 10000
        SearchInIntegerTable("bananaa")
    Next N
    rchWin.Addstring   "End   Searching 10000 words :  Timer = " & Str$(Timer) & " s"
End Sub
'
